// $Id: gucPrefDialog.js,v 1.1 2005/01/03 17:59:49 gramakri Exp $

/* Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Girish Ramakrishnan.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Girish Ramakrishnan <gramakru@uiuc.edu>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 */

var gucPrefs = Components.classes["@mozilla.org/preferences-service;1"].
             getService(Components.interfaces.nsIPrefService).getBranch("guc.");

var observerService = Components.classes["@mozilla.org/observer-service;1"].
             getService(Components.interfaces.nsIObserverService);

var gAction = "";
var gEi = null;

function showInputDialog(title)
{
    document.getElementById("input-dialog").setAttribute("hidden", false);
    document.getElementById("input-dialog-caption").
             setAttribute("label", title + " rule");
    gAction = title;
    document.getElementById("add-rule").disabled = true;
    document.getElementById("edit-rule").disabled = true;
    document.getElementById("delete-rule").disabled = true;
}

function hideInputDialog()
{
    document.getElementById("input-dialog").setAttribute("hidden", true);
    document.getElementById("menutext-input").value = "";
    document.getElementById("searchpattern-input").value = "";
    document.getElementById("url-input").value = "";
    gAction = "";
    document.getElementById("add-rule").disabled = false;
    document.getElementById("edit-rule").disabled = false;
    document.getElementById("delete-rule").disabled = false;
}

function onAdd()
{
   showInputDialog("Add");
}

function onEdit()
{
    var lb = document.getElementById("guc-generic-url-list");
    if (lb.selectedIndex == -1) return;
    gEi = lb.getItemAtIndex(lb.selectedIndex);
    var si = gEi.childNodes;
    document.getElementById("menutext-input").value =
                                        si.item(0).getAttribute("label");
    document.getElementById("searchpattern-input").value =
                                        si.item(1).getAttribute("label");
    document.getElementById("url-input").value = 
                                        si.item(2).getAttribute("label");
    showInputDialog("Edit");
}

function onDelete()
{
    var lb = document.getElementById("guc-generic-url-list");
    if (lb.selectedIndex == -1) return;
    // please tell me why....
    lb.removeItemAt(lb.selectedIndex + 2);
}

function onOk()
{
   if (document.getElementById("menutext-input").value == "") {
          alert("Menu text cannot be empty");
          return;
   }

   var lb = document.getElementById("guc-generic-url-list");

   if (gAction == "Add") {
        var lc1 = document.createElement("listcell");
        lc1.setAttribute("label",
              document.getElementById("menutext-input").value);
        var lc2 = document.createElement("listcell");
        lc2.setAttribute("label", 
              document.getElementById("searchpattern-input").value);
        var lc3 = document.createElement("listcell");
        lc3.setAttribute("label", 
              document.getElementById("url-input").value);
        var li = document.createElement("listitem");
        li.appendChild(lc1);
        li.appendChild(lc2);
        li.appendChild(lc3);
        lb.appendChild(li);
   }
   else if (gAction == "Edit") {
        var si = gEi.childNodes;
        si.item(0).setAttribute("label",
                              document.getElementById("menutext-input").value);
        si.item(1).setAttribute("label",
                              document.getElementById("searchpattern-input").value);
        si.item(2).setAttribute("label",
                              document.getElementById("url-input").value);
   }

   hideInputDialog();
}

function gucLoadSettings()
{
    var i = 1;
    var lb = document.getElementById("guc-generic-url-list");

    document.getElementById("guc-context-menu-text").
           setAttribute("value", gucPrefs.getCharPref("contextMenuText"));

    while (true) {
        if (!gucPrefs.prefHasUserValue("menutext" + i)) break;
        if (gucPrefs.getCharPref("menutext" + i) == "") break;
        var lc1 = document.createElement("listcell");
        lc1.setAttribute("label", gucPrefs.getCharPref("menutext" + i));
        var lc2 = document.createElement("listcell");
        lc2.setAttribute("label", gucPrefs.getCharPref("searchpattern" + i));
        var lc3 = document.createElement("listcell");
        lc3.setAttribute("label", gucPrefs.getCharPref("url" + i));
        var li = document.createElement("listitem");
        li.appendChild(lc1);
        li.appendChild(lc2);
        li.appendChild(lc3);
        lb.appendChild(li);
        i = i + 1;
    }
}

function gucSaveSettings()
{
    var lb = document.getElementById("guc-generic-url-list");

    gucPrefs.setCharPref("contextMenuText",
        document.getElementById("guc-context-menu-text").value);
    
    var i;
    for(i = 1; i<=lb.getRowCount(); i++) {
        var li = lb.getItemAtIndex(i-1);
        var si = li.childNodes;
        gucPrefs.setCharPref("menutext"+i, si.item(0).getAttribute("label"));
        gucPrefs.setCharPref("searchpattern"+i, si.item(1).getAttribute("label"));
        gucPrefs.setCharPref("url"+i, si.item(2).getAttribute("label"));
    }
    
    // end of file
    gucPrefs.setCharPref("menutext"+i, "");
    gucPrefs.setCharPref("searchpattern"+i, "");
    gucPrefs.setCharPref("url"+i, "");

    observerService.notifyObservers(null, "guc-settings", "changed");

    return true;
}

